(letrec
    (; switch: Switches between two streams.
     (switch (lambda (x:chan) (call/cc (lambda (k0)
					 ((cdr x:chan) (cons (car x:chan) 
							     k0))))))

     ; get: Retrieves a value from an upstream.
     (get (lambda (chan) (switch (cons #f chan))))

     ; put: Sends a value to a downstream.
     (put (lambda (x:chan) (cdr (switch x:chan))))
     
     ; compose-pull:
     (compose-pull (lambda (t1 t2)
                     (lambda (u:d)
                       (let ((u (car u:d))
                             (d (cdr u:d)))
                         (call/cc (lambda (k) 
                                    (t1 (cons u (cdr (call/cc (lambda (k0)
                                                                (k (t2 (cons k0 d))))))))))))))
                           
                     
     ; st-pull;
     (st-pull (lambda (src t)
                (lambda (d)
                  (call/cc (lambda (k)
                             (src (cdr (call/cc (lambda (k0) 
                                                  (k (t (cons k0 d))))))))))))

     ; ss-pull:
     (ss-pull (lambda (src snk)
		(call/cc (lambda (k)
			   (src
			    (cdr (call/cc (lambda (u)
					    (k (snk u))))))))))

     ; Cons sugar.
     (cons (lambda (a b)
	     (lambda (on-cons on-nil)
	       (on-cons a b))))

     (car (lambda (cell)
	    (cell (lambda (a b) a) #f)))

     (cdr (lambda (cell)
	    (cell (lambda (a b) b) #f)))

     (nil (lambda (on-cons on-nil) (on-nil)))
     
     ; Church options.
     (SOME (lambda (val) (lambda (on-SOME on-NONE)
			   (on-SOME val))))
     
     (NONE (lambda () (lambda (on-SOME on-NONE)
			(on-NONE))))

     (match-option (lambda (opt if-SOME if-NONE)
		     (opt if-SOME if-NONE)))

     ; Church trees.
     (NODE (lambda (left right) (lambda (on-NODE on-LEAF)
				  (on-NODE left right))))

     (LEAF (lambda (el) (lambda (on-NODE on-LEAF)
			  (on-LEAF el))))

     (match-tree (lambda (tree if-NODE if-LEAF)
		   (tree if-NODE if-LEAF)))

     ; Toy transducers.
     
     (doubler (lambda (u:d)
                (let ((get-u (get (car u:d))))
                  (match-option (car get-u)
                                (lambda (n)
                                  (doubler (cons (cdr get-u)
                                                 (put (cons (SOME (* 2 n)) (cdr u:d))))))
                                (lambda ()
                                  (doubler (cons (cdr get-u)
                                                 (put (cons (NONE) (cdr u:d))))))))))

     (display-sink (lambda (u)
                     (let ((get-u (get u)))
                       (match-option (car get-u)
                                     (lambda (el) (begin (display el)
                                                         (display-sink (cdr get-u))))
                                     (lambda () #f)))))
                           
                       
    
     (put-tree (lambda (tree)
                 (lambda (d)
                   (put (cons (NONE) ((put-tree-help tree) d)))))) 
                  
     
     (put-tree-help (lambda (tree)
                      (lambda (d)
                        (match-tree tree
                                    (lambda (l r)
                                      ((put-tree-help l) ((put-tree-help r) d)))
                                    (lambda (el)
                                      (put (cons (SOME el) d)))))))
     
     )

  ; streamify(tree) >> doubler >> display-sink
  (let ((tree (NODE (LEAF 3) (LEAF 2))))
    (ss-pull (st-pull (put-tree tree) doubler) display-sink))
  
  )
		     
  

