module Imperative.Pointer where

import qualified Data.Map as Map
import qualified Control.Monad.State as St

data Pointer a = Pointer !Int
	       | Null
 deriving (Eq,Ord)


data Heap object = Heap { heapMax :: !(Pointer object),
			  heapMap :: !(Map.Map (Pointer object) object) }



getIn heap ptr = (heapMap heap) Map.! ptr

setIn heap ptr o = heap {heapMap=Map.insert ptr o (heapMap heap)}

newIn heap o = Heap { heapMax = ptr' ,
		      heapMap = Map.insert ptr' o (heapMap heap) }
 where ptr' = bump (heapMax heap)
       bump (Pointer i) = (Pointer (i+1))

