module Lattice.Lattice where

import qualified Data.Set as Set
-- import qualified InfiniteMap as IMap

 -- A lattice library.
 
class Eq a => Lattice a where
 top  :: a
 bot  :: a
 (<:) :: a -> a -> Bool
 join :: a -> a -> a
 meet :: a -> a -> a

 joins :: [a] -> a

 lfp  :: (a -> a) -> a
 gfp  :: (a -> a) -> a


 -- By default, a lattice is flat.
 top = error "top!"
 bot = error "bot!"
 x <: y = x == y   || 
          x == bot || 
          y == top
 x `join` y | x <: y    = y
            | y <: x    = x
            | otherwise = top
 x `meet` y | x <: y    = x
            | y <: x    = y
            | otherwise = bot
 
 joins []      = bot
 joins [a]     = a
 joins (hd:tl) = hd `join` (joins tl)

 lfp f = lfp' bot
  where lfp' a = if f a == a
                 then a
                 else lfp' (f a)

 gfp f = gfp' top
  where gfp' a = if f a == a
                 then a
                 else gfp' (f a)

